arcave/urls.py
from django.conf import settings
from django.contrib import admin
from django.views.generic import TemplateView
from django.contrib.auth.views import LogoutView, LoginView
from django.urls import path, re_path
from django.views.static import serve

from documents.views import DocumentView, DocumentCommentView, DocumentUpdateView, DocumentActionView, \
    DocumentListView, DocumentCommentListView, DocumentsSearchView, DocumentDetailView, DokumanTag, AuthorSearch
from users.views import RegistrationView, ProfileUpdateView, UserDetailView
from authors.views import AuthorView, AuthorUpdateView, AuthorListView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', TemplateView.as_view(template_name="users/homepage.html"), name='homepage'),
    path('users/register/', RegistrationView.as_view(), name='register'),
    path('login/', LoginView.as_view(), name='login'),
    path('authors/author/', AuthorView.as_view(), name='author_adds'),
    path('authors/author_list/', AuthorListView.as_view(), name='author_list'),
    path('documents/<int:document_id>/documentcomment/', DocumentCommentView.as_view(), name='documentcomment'),
    path('documents/document/', DocumentView.as_view(), name='document'),
    path('detail/<int:document_id>/edit_form/', DocumentUpdateView.as_view(), name='document_edit_form'),
    path('detail/<int:document_id>/edit/', DocumentActionView.as_view(action="edit"), name='doc_edit'),
    path('authors/update/', AuthorUpdateView.as_view(), name='author_update'),
    path('documents/<int:document_id>/', DocumentDetailView.as_view(), name='detail'),
    path('detail/<int:document_id>/remove/', DocumentActionView.as_view(action="remove", validate=True),
         name='doc_remove'),
    path('logout', LogoutView.as_view(), name='logout'),
    path('documents/', DocumentListView.as_view(), name='document_list'),
    path('documents/document_comment_list/', DocumentCommentListView.as_view(), name='document_comment_list'),
    path('search_result/', DocumentsSearchView.as_view(), name='search'),
    path('category/<str:category>/', DokumanTag.as_view(), name='tag_result'),
    path('author_name/<str:author_name>/', AuthorSearch.as_view(), name='author_result'),

    path('profile/', ProfileUpdateView.as_view(), name='update_profile'),
    path('detail/me/', UserDetailView.as_view(is_me=True), name='me'),
    path('detail/<int:pk>/', UserDetailView.as_view(), name='user_detail'),

]
if settings.DEBUG:
    urlpatterns.append(re_path(r'^media/(?P<path>.*)$',
                               serve,
                               {'document_root': settings.MEDIA_ROOT, 'show_indexes': True}))

users/urls.py
from django.urls import path, include

from users.views import RegistrationView, ProfileUpdateView, UserDetailView
from . import views

urlpatterns = [

]

documents/models.py
import hashlib

from django.db import models
from django.conf import settings
from django.forms import Media

from authors.models import Authors
from django.core.files.storage import FileSystemStorage
# Create your models here.

kategori_secim = ('Scene', 'Scene'), ('Art', 'Art'), ('Political', 'Political'), ('Scholar', 'Scholar'), (
    'Child', 'Child'), ('Philosophy', 'Philosophy'), ('Religion', 'Religion'), ('History', 'History')


class MediaFileSystemStorage(FileSystemStorage):
    def get_available_name(self, name, max_length=None):
        if max_length and len(name) > max_length:
            raise(Exception("name's length is greater than max_length"))
        return name

    def _save(self, name, content):
        if self.exists(name):
            return name
        return super(MediaFileSystemStorage, self)._save(name, content)


class Documents(models.Model):
    owner = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.DO_NOTHING)
    name = models.CharField(max_length=50, verbose_name='Document Name:')
    category = models.CharField(choices=kategori_secim, max_length=50, verbose_name='Category:')
    file = models.FileField(verbose_name='File to upload', storage=MediaFileSystemStorage(), null=False, blank=True)
    date = models.DateTimeField()
    upload_date = models.DateTimeField(auto_now=True, blank=True)
    # size = models.IntegerField()
    description = models.TextField(max_length=400, blank=True)
    author = models.ForeignKey(Authors, null=True, on_delete=models.DO_NOTHING)
    md5sum = models.CharField(max_length=36)

    def __str__(self):
        return self.name

    def save(self, *args, **kwargs):
        if not self.pk:  # file is new
            md5 = hashlib.md5()
            for chunk in self.file.chunks():
                md5.update(chunk)
            self.md5sum = md5.hexdigest()
        super(Documents, self).save(*args, **kwargs)


class DocumentsComment(models.Model):
    documents = models.ForeignKey(Documents, on_delete=models.CASCADE, related_name='comments', verbose_name='Document Name:')
    owner = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.DO_NOTHING)
    comment = models.TextField(max_length=300)
    created = models.DateTimeField(auto_now_add=True)
    updated = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.comment

documents/forms.py
from django import forms
from documents.models import Documents, DocumentsComment


class RealDateInput(forms.DateInput):
    input_type = 'date'


class DocumentCreateForm(forms.ModelForm):
    date = forms.DateField(widget=RealDateInput, input_formats=['%Y-%m-%d'])

    class Meta:
        model = Documents

        fields = [
            'owner', 'name', 'category', 'date', 'file', 'description', 'author'
        ]
        widget = {
            'date': RealDateInput
        }


class DocumentUpdateForm(forms.ModelForm):
    date = forms.DateField(widget=RealDateInput, input_formats=['%Y-%m-%d'])

    class Meta:
        model = Documents
        fields = ['owner', 'name', 'category', 'date', 'file', 'description', 'author']


class DocumentCommentCreateForm(forms.ModelForm):
    # def __init__(self, *args, **kwargs):
    #     # self.request = kwargs.pop("request")
    #     self.request = kwargs.pop('request')
    #     super(DocumentCommentCreateForm, self).__init__(*args, **kwargs)
    #
    # def save(self, commit=True):
    #     obj = super(DocumentCommentCreateForm, self).save(False)
    #     obj.owner = self.request.user
    #     obj.save()
    #     return obj

    class Meta:
        model = DocumentsComment

        fields = [
         'comment',
        ]


class CommentForm(forms.ModelForm):
    class Meta:
        model = DocumentsComment
        fields = [
            'comment',
        ]

documents/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.messages.views import SuccessMessageMixin
from django.db.models import Q
from django.shortcuts import render
from django.urls import reverse, reverse_lazy
from django.utils.translation import gettext_noop
from documents.forms import DocumentCreateForm, DocumentCommentCreateForm, DocumentUpdateForm
from django.views.generic import UpdateView, CreateView, DetailView, ListView, RedirectView
from documents.models import Documents, DocumentsComment


class DocumentListView(LoginRequiredMixin, ListView):
    model = Documents
    template_name = 'documents/documentlist.html'
    context_object_name = 'documents'
    login_url = '/login'
    ordering = ['-upload_date']


class DocumentCommentListView(LoginRequiredMixin, ListView):
    model = DocumentsComment
    context_object_name = 'documentcomment'
    template_name = 'documents/document_comment_list.html'
    success_url = reverse_lazy('document_comment_list')


class DocumentView(SuccessMessageMixin, LoginRequiredMixin, CreateView):
    form_class = DocumentCreateForm
    template_name = 'documents/document.html'
    success_url = reverse_lazy('document_list')
    success_message = " Document created successfully"


class DocumentCommentView(SuccessMessageMixin, LoginRequiredMixin, CreateView):
    form_class = DocumentCommentCreateForm
    template_name = 'documents/documentcomment.html'
    success_url = reverse_lazy('document_comment_list')
    model = DocumentsComment
    success_message = " Comment created successfully"

    def get_object(self):
        document = Documents.objects.get(id=self.kwargs['document_id'])
        return document

    def form_valid(self, form):
        form.instance.documents = self.get_object()
        form.instance.owner = self.request.user
        return super(DocumentCommentView, self).form_valid(form)


class DocumentUpdateView(SuccessMessageMixin, LoginRequiredMixin, UpdateView):
    model = Documents
    form_class = DocumentUpdateForm
    success_url = reverse_lazy("documentlist")
    pk_url_kwarg = "document_id"
    success_message = "Updated successfully"

    def get_success_url(self):
        return reverse("detail", kwargs={"document_id": self.kwargs["document_id"]})

    # def form_valid(self, form):
    #     form.save()
    #     # Formlarımızda sorun yoksa bu metod çalışacak.
    #     # Bildirimimizi messages.success ile ekleyeceğiz.
    #     messages.success(self.request, 'It has been updated.')
    #     return super().form_valid(form)
    #
    #
    # def form_invalid(self, form):
    #     # Formlarımızda sorun varsa bu metod çalışacak.
    #     # Bir hata mesajı göstermek istediğimiz için messages.error kullanıyoruz.
    #     messages.error(self.request, 'It could not be updated, please check the form.')
    #     return super().form_invalid(form)
    #


class DocumentDetailView(DetailView):
    model = Documents
    pk_url_kwarg = "document_id"


class DocumentActionView(LoginRequiredMixin, RedirectView):
    action = None
    validate = False
    url = None

    def get_redirect_url(self, *args, **kwargs):
        return self.url or reverse("detail", kwargs={'document_id': self.kwargs["document_id"]})

    def apply_action(self, action):
        if action == gettext_noop("remove"):
            self.document.delete()
            self.url = reverse("documentlist")
        elif action == gettext_noop("edit"):
            self.url = reverse("document_edit_form", kwargs={'document_id': self.kwargs["document_id"]})
        else:
            pass

    def get(self, request, *args, **kwargs):
        self.document = Documents.objects.get(id=self.kwargs["document_id"])
        if request.GET.get("valid") == 'false':
            return super().get(request, *args, **kwargs)
        elif self.validate and not request.GET.get("valid") == 'true':
            return render(request, "users/validate.html", {"action": self.action, "object": self.document})
        else:
            self.apply_action(self.action)
            return super().get(request, *args, **kwargs)


class DocumentsSearchView(ListView):
    model = Documents
    template_name = 'documents/search_result.html'

    def get_queryset(self):
        query = self.request.GET.get('q')
        search_result = Documents.objects.filter(
            Q(author__documents__name__icontains=query)
        )
        return search_result


def num_post(request):
    return Documents.objects.count()
    # return render(request, 'documentlist.html', {'num_post': num_post})


class DokumanTag(ListView):
    model = Documents
    template_name = 'documents/tag_result.html'
    context_object_name = 'qs'

    def get_queryset(self):
        return self.model.objects.filter(Q(category__icontains=self.kwargs['category']))


class AuthorSearch(ListView):
    model = Documents
    template_name = 'documents/author_result.html'
    context_object_name = 'j'

    def get_queryset(self):
        return self.model.objects.filter(Q(author__author_name=self.kwargs))

documents/templates/documents/author_result.html
{% extends "users/base.html" %}
{% load crispy_forms_tags %}
{% block title %}Document Result According to Author{% endblock %}
{% block body %}
{% block content %}
<br>
<h2 align="center">Document Result According to Author</h2>
<form method="POST" class="form-group" style="margin-top: 5%;">
    <div class="container">
        <div class="align-left">
            <table class="table fa-border">
                <tr>
                    <th>Document Name</th>
                    <th>File</th>
                    <th>Date</th>

                </tr>
                {% for i in j %}
                <tr>
                    <td>{{ i.name }}</td>
                    <td>{{ i.file }}</td>
                    <td>{{ i.date }}</td>

                </tr>
                {% endfor %}
            </table>
        </div>
    </div>
</form>
{% endblock content %}
{% endblock body %}

documents/templates/documents/document.html
{% extends 'users/base.html' %}
{% load crispy_forms_tags %}
{% block title %}Create an Account{% endblock %}
{% block body %}
<br>
<h2 align="center">Document</h2>
<hr>
<form method="POST" class="form-group" style="margin-top: 5%;">
	{% csrf_token %}
	<div class="col-md-10 offset-md-4" >
		<div class="col-6">
		{{ form|crispy }}
		<div class="col-md-10 offset-md-4">
			<button type="submit" class="btn btn-success">Save</button>
		</div>
		</div>
	</div>
</form>

{% endblock body %}

documents/templates/documents/document_comment_list.html
{% extends "users/base.html" %}
{% load crispy_forms_tags %}
{% block title %}Document List{% endblock %}
{% block body %}
<h2 align="center">All Comments</h2>
<form method="POST" class="form-group" style="margin-top: 5%;">
    <div class="container">
        <div class="align-left">
            <table class="table fa-border">
                <tr>
                    <th>Comment Owner</th>
                    <th>Comment</th>
                    <th>Create Date</th>
<!--                    <th>Update Date</th>-->
                </tr>
                {% for i in documentcomment %}
                <tr>
                    <td>{{ i.owner }}</td>
                    <td>{{ i.comment }}</td>
                    <td>{{ i.created | timesince }}</td>
<!--                    <td>{{ i.updated }}</td>-->
                </tr>
                {% endfor %}
            </table>
        </div>
    </div>
</form>

{% endblock body %}

documents/templates/documents/documentcomment.html
{% extends 'users/base.html' %}
{% load crispy_forms_tags %}
{% block title %}Create an Account{% endblock %}
{% block body %}

<br>
<h2 align="center">Document Comment</h2>
<hr>


<form method="POST" class="form-group" style="margin-top: 5%;">
{% csrf_token %}
	<div class="row justify-content-center">
		<div class="col-md-6 offset-md-1" >
		{{ form|crispy }}
		<div class="col-md-7 offset-md-5">

			<button type="submit" class="btn btn-success">Save</button>

		</div>
		</div>
	</div>

</form>
{% endblock body %}

documents/templates/documents/documentlist.html
{% extends "users/base.html" %}
{% load crispy_forms_tags %}
{% block title %}Document List{% endblock %}
{% block body %}
<br>
<div class="row">
  <div class="col-sm-6">
    <div class="card">
      <div class="card-body">
        <h5 class="card-title">Total Document Number</h5>
        <p class="card-text">Total document number is {{num_post}} so far.</p>
<!--        <a href="#" class="btn btn-primary">Go somewhere</a>-->


      </div>
    </div>
  </div>
  <div class="col-sm-6">
    <div class="card">
      <div class="card-body">
        <h5 class="card-title">Search with Tag?</h5>
        <p class="card-text"></p>
        <a href="{% url 'tag_result'  category='Art'  %}" class="btn btn-primary">#Art</a>
        <a href="{% url 'tag_result'  category='Scene'  %}" class="btn btn-primary">#Scene</a>
        <a href="{% url 'tag_result'  category='Political'  %}" class="btn btn-primary">#Political</a>
        <a href="{% url 'tag_result'  category='Scholar'  %}" class="btn btn-primary">#Scholar</a>
        <a href="{% url 'tag_result'  category='Child'  %}" class="btn btn-primary">#Child</a>
        <a href="{% url 'tag_result'  category='Philosophy'  %}" class="btn btn-primary">#Philosophy</a>
        <a href="{% url 'tag_result'  category='Religion'  %}" class="btn btn-primary">#Religion</a>
        <a href="{% url 'tag_result'  category='History'  %}" class="btn btn-primary">#History</a>
        <a href="{% url 'tag_result'  category='Chemistry'  %}" class="btn btn-primary">#Chemistry</a>

      </div>
    </div>
  </div>
</div>
<br>
<br>
<br>
<h2 align="center">All Documents</h2>
<form method="POST" class="form-group" style="margin-top: 5%;">
    <div class="container">

        <div class="align-left">

            <table class="table fa-border">
                <tr>
                    <th>Document Name</th>
                    <th>Category</th>
                    <th>Author</th>
                    <th>Upload Date</th>
                    <th>File</th>
                </tr>

                {% for i in documents %}
                <tr>
                    <td>{{ i.name }}</td>
                    <td>{{ i.category }}</td>
                    <td>{{ i.author }}</td>
                    <td>{{ i.upload_date }}</td>
                    <td>{{ i.file }}</td>
                    <td><a class="btn btn-secondary btn-sm" href="{% url 'detail' i.id %}">Detail</a></td>
                    <td><a class="btn btn-secondary btn-sm" href="{% url 'documentcomment' i.id %}">Comment</a></td>

                </tr>
                {% endfor %}
            </table>
        </div>
    </div>
</form>


{% endblock body %}

documents/templates/documents/documents_detail.html
{% extends 'users/base.html' %}
{% load crispy_forms_tags %}
{% block title %}Create an Account{% endblock %}
{% block body %}
{% block content %}
<br>
<h2 align="center">Document Detail</h2>
<hr>
<form method="POST" class="form-group" style="margin-top: 5%;">
    {% csrf_token %}
    <div class="col-md-10 offset-md-4">
        <div class="col-6">
            {{ form|crispy }}

<!--            <p>ID - {{ object.id}}</p>-->
            <p>Owner - {{ object.owner }}</p>
            <p>Category - {{ object.category }}</p>
            <p>Name - {{ object.name }}</p>
            <p>Content  - {{ object.file }}</p>
            <p>Description  - {{ object.description }}</p>
            <p>Author  - {{ object.author }}</p>
            <p>Publishing Date - {{ object.upload_date }}</p>
            <hr>
            <div class="col-md-10 offset-md-3">
                <a class="btn btn-sm btn-primary" href="{% url 'doc_remove' document_id=object.id %}"><small>
            </small>Remove</a>
                <a class="btn btn-sm btn-primary" href="{% url 'doc_edit' document_id=object.id %}"><small>
            </small>Edit</a>

            </div>
        </div>
    </div>
</form>
{% endblock content %}
{% endblock body %}

documents/templates/documents/documents_form.html
{% extends 'users/base.html' %}
{% load crispy_forms_tags %}
{% block title %}Create an Account{% endblock %}
{% block body %}

<br>
<h2 align="center">Edit Post</h2>
<hr>
<form method="POST" class="form-group" style="margin-top: 5%;">
	{% csrf_token %}
	<div class="col-md-10 offset-md-4" >
		<div class="col-6">
		{{ form|crispy }}
		<div class="col-md-10 offset-md-4">
			<button type="submit" class="btn btn-success">Save</button>

		</div>
		</div>
	</div>
</form>

{% endblock body %}

documents/templates/documents/search_result.html
{% extends "users/base.html" %}
{% block body %}
<h2 align="center">Search Result</h2>
<br>
<div class="container">
    <div class="align-left">

        <table class="table fa-border">
            <tr>
                <th>Author</th>
                <th>Category</th>
                <th>Date</th>
                <th>File</th>
                <th>Name</th>
                <th>Description</th>
            </tr>
            {% for i in documents_list %}
            <tr>
                <td>{{ i.author}} -</td>
                <td>{{ i.category}}</td>
                <td>{{ i.date }}</td>
                <td>{{ i.file}}</td>
                <td>{{ i.name }}</td>
                <td>{{ i.description }}</td>


                <!--        </tr>-->
                {% endfor %}
        </table>
    </div>
</div>
{% endblock %}

documents/templates/documents/tag_result.html
{% extends "users/base.html" %}
{% load crispy_forms_tags %}
{% block title %}Document List{% endblock %}
{% block body %}
{% block content %}
<br>
<h2 align="center">Tag Result</h2>
<form method="POST" class="form-group" style="margin-top: 5%;">
    <div class="container">
        <div class="align-left">
            <table class="table fa-border">
                <tr>
                    <th>Document Name</th>
                    <th>Category</th>
                    <th>Author</th>
                    <th>Upload Date</th>
                    <th>File</th>
                </tr>
                {% for i in qs %}
                <tr>
                    <td>{{ i.name }}</td>
                    <td>{{ i.category }}</td>
                    <td>{{ i.author }}</td>
                    <td>{{ i.upload_date }}</td>
                    <td>{{ i.file }}</td>
                </tr>
                {% endfor %}
            </table>
        </div>
    </div>
</form>
{% endblock content %}
{% endblock body %}